<script setup>
import AppShare from '@/helpers/AppShare'
import { useDialogStore } from '@/stores/DialogStore';
import { useAppStore } from '@/stores/AppStore'
</script>


<script>
export default {

	data() {
		const appStore = useAppStore()
		return {
			appStore,
			currentPassword: '',
			newPassword: '',
			confirmPassword: '',
		}
	},

	methods: {
		async onSubmit() {
			const dialogStore = useDialogStore()

			if (this.newPassword !== this.confirmPassword) {
				dialogStore.warningBox(this.$t('validator.isSamePasswords'))
				return
			}

			const result = await dialogStore.waitBox(async () =>
				await AppShare.client.call(`profile/password`, {
					method: 'PUT',
					headers: AppShare.client.defaultHeaders(),
					data: {
						member: {
							currentPassword: this.currentPassword,
							newPassword: this.newPassword,
							confirmPassword: this.confirmPassword,
						},
					},
				})
			)
			if (!dialogStore.handleRestError(result)) {
				dialogStore.infoBox(this.$t('confirm'))
				this.$router.push({ name: 'signout' })
			}
		}
	},

	i18n: {
		messages: {
			en: {
				title: "Change Password",
				currentPassword: "Current Password",
				newPassword: "New Password",
				confirmPassword: "Confirm Password",
				ok: "Change Password",
				confirm: "You have to sign-out, then sign-in again with new password!",
			},
			th: {
				title: "เปลี่ยนรหัสผ่าน",
				currentPassword: "รหัสผ่านปัจจุบัน",
				newPassword: "รหัสผ่านใหม่",
				confirmPassword: "ยืนยันรหัสผ่านใหม่",
				ok: "เปลี่ยนรหัสผ่าน",
				confirm: "คุณต้องออกจากระบบ แล้วเข้าระบบใหม่ ด้วยรหัสผ่านใหม่!",
			},
		},
	},
}
</script>


<template>
	<AuthenRequired>
		<AppBox :title="$t('title')">
			<form id="form" @submit.prevent="onSubmit">
				<!-- current password -->
				<label for="currentPassword">{{ $t('currentPassword') }}</label><br />
				<input id="currentPassword" type="password" :placeholder="$t('currentPassword')" required minlength="4"
					maxlength="20" v-model="currentPassword" /><br />
				<br />

				<!-- new password -->
				<label for="newPassword">{{ $t('newPassword') }}</label><br />
				<input id="newPassword" type="password" :placeholder="$t('newPassword')" required minlength="4"
					maxlength="20" v-model="newPassword" /><br />
				<br />

				<!-- confirm password -->
				<label for="confirmPassword">{{ $t('confirmPassword') }}</label><br />
				<input id="confirmPassword" type="password" :placeholder="$t('confirmPassword')" required minlength="4"
					maxlength="20" v-model="confirmPassword" /><br />
				<br />

				<button type="submit">{{ $t('ok') }}</button>
			</form>
		</AppBox>
	</AuthenRequired>
</template>


<style scoped>
</style>
